#ifndef ARGSET_CONTAINS_HH
#define ARGSET_CONTAINS_HH

#include "ctif.hh"
#include "argsets.hh"

namespace FuncImpl
{
    template<typename Func,typename ArgSet>
    struct ComposedFunc;
}


namespace ArgSets
{
    template<typename Arg,typename ElementToFind>
    struct ArgContains
    {
	static const bool result=false;
    };
    
    template<typename ElementToFind>
    struct ArgContains<ElementToFind,ElementToFind>
    {
	static const bool result=true;
    };
    
    template<typename ArgSet,typename ElementToFind>
    struct ArgSetContains
    {
	static const bool result=CT::If<ArgContains<typename ArgSet::Arg,ElementToFind>::result,
					CT::True,
					ArgSetContains<typename ArgSet::Base,ElementToFind> >::Type::result;
    };
    
    template<typename ElementToFind>
    struct ArgSetContains<ArgSet0,ElementToFind>
    {
	static const bool result=false;
    };

    template<typename Func,typename ArgSet,typename ElementToFind>
    struct ArgContains<FuncImpl::ComposedFunc<Func,ArgSet>,ElementToFind>
    {
	static const bool result=ArgSetContains<ArgSet,ElementToFind>::result;
    };
}

#endif
