#ifndef RTHELPER_HH
#define RTHELPER_HH

#include <functional>
#include "argsets.hh"
#include "exprtype.hh"
#include "ctif.hh"

namespace FuncImpl
{
    // deduce the return type for a function
    template<typename Func,typename ArgSet,unsigned numArgs=ArgSets::CountArgs<ArgSet>::result>
    struct DeduceReturnType
    {};

    template<typename Func,typename ArgSet>
    struct DeduceReturnType<Func,ArgSet,0>
    {
	typedef ExprType::RValueLValueType<
	    typename EXPR_TYPE(ExprType::makeT<const Func&>()())
	    >::Type Type;
    };
    template<typename Func,typename ArgSet>
    struct DeduceReturnType<Func,ArgSet,1>
    {
	typedef ExprType::RValueLValueType<
	    typename EXPR_TYPE(ExprType::makeT<const Func&>()(ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,1>::Type&>()))
	    >::Type Type;
    };
    template<typename Func,typename ArgSet>
    struct DeduceReturnType<Func,ArgSet,2>
    {
	typedef ExprType::RValueLValueType<
	    typename EXPR_TYPE(ExprType::makeT<const Func&>()(ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,1>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,2>::Type&>()))
	    >::Type Type;
    };
    template<typename Func,typename ArgSet>
    struct DeduceReturnType<Func,ArgSet,3>
    {
	typedef ExprType::RValueLValueType<
	    typename EXPR_TYPE(ExprType::makeT<const Func&>()(ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,1>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,2>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,3>::Type&>()))
	    >::Type Type;
    };
    template<typename Func,typename ArgSet>
    struct DeduceReturnType<Func,ArgSet,4>
    {
	typedef ExprType::RValueLValueType<
	    typename EXPR_TYPE(ExprType::makeT<const Func&>()(ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,1>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,2>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,3>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,4>::Type&>()))
	    >::Type Type;
    };
    template<typename Func,typename ArgSet>
    struct DeduceReturnType<Func,ArgSet,5>
    {
	typedef ExprType::RValueLValueType<
	    typename EXPR_TYPE(ExprType::makeT<const Func&>()(ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,1>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,2>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,3>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,4>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,5>::Type&>()))
	    >::Type Type;
    };
    template<typename Func,typename ArgSet>
    struct DeduceReturnType<Func,ArgSet,6>
    {
	typedef ExprType::RValueLValueType<
	    typename EXPR_TYPE(ExprType::makeT<const Func&>()(ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,1>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,2>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,3>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,4>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,5>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,6>::Type&>()))
	    >::Type Type;
    };
    template<typename Func,typename ArgSet>
    struct DeduceReturnType<Func,ArgSet,7>
    {
	typedef ExprType::RValueLValueType<
	    typename EXPR_TYPE(ExprType::makeT<const Func&>()(ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,1>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,2>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,3>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,4>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,5>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,6>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,7>::Type&>()))
	    >::Type Type;
    };
    template<typename Func,typename ArgSet>
    struct DeduceReturnType<Func,ArgSet,8>
    {
	typedef ExprType::RValueLValueType<
	    typename EXPR_TYPE(ExprType::makeT<const Func&>()(ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,1>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,2>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,3>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,4>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,5>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,6>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,7>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,8>::Type&>()))
	    >::Type Type;
    };
    template<typename Func,typename ArgSet>
    struct DeduceReturnType<Func,ArgSet,9>
    {
	typedef ExprType::RValueLValueType<
	    typename EXPR_TYPE(ExprType::makeT<const Func&>()(ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,1>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,2>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,3>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,4>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,5>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,6>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,7>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,8>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,9>::Type&>()))
	    >::Type Type;
    };
    template<typename Func,typename ArgSet>
    struct DeduceReturnType<Func,ArgSet,10>
    {
	typedef ExprType::RValueLValueType<
	    typename EXPR_TYPE(ExprType::makeT<const Func&>()(ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,1>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,2>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,3>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,4>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,5>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,6>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,7>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,8>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,9>::Type&>(),
								  ExprType::makeT<const typename ArgSets::GetASEntry<ArgSet,10>::Type&>()))
	    >::Type Type;
    };

    // retrieve the result_type typedef from a function object
    template<typename Func>
    struct ExtractResultType
    {
	typedef typename Func::result_type Type;
    };

    // HasResultType::result is true for functors derived from
    // std::unary_function<> or std::binary_function<>
    // otherwise it is false.
    // should be specialized to return true for individual functor types that provide
    // such a typedef
    namespace HasResultTypeHelper
    {
	struct TrueType
	{
	    char a[2];
	};
	
	typedef char FalseType;

	template<typename Arg,typename Result>
	static TrueType check(const std::unary_function<Arg,Result>*);

	template<typename Arg1,typename Arg2,typename Result>
	static TrueType check(const std::binary_function<Arg1,Arg2,Result>*);

	static FalseType check(...);	
    }
    


    template<typename Func>
    struct HasResultType
    {
	static const bool result=(sizeof(HasResultTypeHelper::check(ExprType::makeT<const Func*>()))==sizeof(HasResultTypeHelper::TrueType));
    };

    // HasResultHelper::result should be true for functors that have a member template ResultHelper<>

    template<typename Func>
    struct HasResultHelper
    {
	static const bool result=false;
    };

    // If the functor has ResultHelper, use it
    // primary template declares count as third arg, derived from second
    template<typename Func,typename ArgSet,unsigned argCount=ArgSets::CountArgs<ArgSet>::result>
    struct ExtractResultFromHelper
    {};
    
    // now specialize based on third arg
    template<typename Func,typename ArgSet>
    struct ExtractResultFromHelper<Func,ArgSet,0>
    {
	// ResultHelper must have all-default args if no args supplied
	typedef typename Func::template ResultHelper<>::Type Type;
    };
    
    template<typename Func,typename ArgSet>
    struct ExtractResultFromHelper<Func,ArgSet,1>
    {
	typedef typename Func::template ResultHelper<
	    typename ArgSets::GetASEntry<ArgSet,1>::Type
	    >::Type Type;
    };
    
    template<typename Func,typename ArgSet>
    struct ExtractResultFromHelper<Func,ArgSet,2>
    {
	typedef typename Func::template ResultHelper<
	    typename ArgSets::GetASEntry<ArgSet,1>::Type,
	    typename ArgSets::GetASEntry<ArgSet,2>::Type
	    >::Type Type;
    };
        
    template<typename Func,typename ArgSet>
    struct ExtractResultFromHelper<Func,ArgSet,3>
    {
	typedef typename Func::template ResultHelper<
	    typename ArgSets::GetASEntry<ArgSet,1>::Type,
	    typename ArgSets::GetASEntry<ArgSet,2>::Type,
	    typename ArgSets::GetASEntry<ArgSet,3>::Type
	    >::Type Type;
    };
        
    template<typename Func,typename ArgSet>
    struct ExtractResultFromHelper<Func,ArgSet,4>
    {
	typedef typename Func::template ResultHelper<
	    typename ArgSets::GetASEntry<ArgSet,1>::Type,
	    typename ArgSets::GetASEntry<ArgSet,2>::Type,
	    typename ArgSets::GetASEntry<ArgSet,3>::Type,
	    typename ArgSets::GetASEntry<ArgSet,4>::Type
	    >::Type Type;
    };
        
    template<typename Func,typename ArgSet>
    struct ExtractResultFromHelper<Func,ArgSet,5>
    {
	typedef typename Func::template ResultHelper<
	    typename ArgSets::GetASEntry<ArgSet,1>::Type,
	    typename ArgSets::GetASEntry<ArgSet,2>::Type,
	    typename ArgSets::GetASEntry<ArgSet,3>::Type,
	    typename ArgSets::GetASEntry<ArgSet,4>::Type,
	    typename ArgSets::GetASEntry<ArgSet,5>::Type
	    >::Type Type;
    };
        
    template<typename Func,typename ArgSet>
    struct ExtractResultFromHelper<Func,ArgSet,6>
    {
	typedef typename Func::template ResultHelper<
	    typename ArgSets::GetASEntry<ArgSet,1>::Type,
	    typename ArgSets::GetASEntry<ArgSet,2>::Type,
	    typename ArgSets::GetASEntry<ArgSet,3>::Type,
	    typename ArgSets::GetASEntry<ArgSet,4>::Type,
	    typename ArgSets::GetASEntry<ArgSet,5>::Type,
	    typename ArgSets::GetASEntry<ArgSet,6>::Type
	    >::Type Type;
    };
        
    template<typename Func,typename ArgSet>
    struct ExtractResultFromHelper<Func,ArgSet,7>
    {
	typedef typename Func::template ResultHelper<
	    typename ArgSets::GetASEntry<ArgSet,1>::Type,
	    typename ArgSets::GetASEntry<ArgSet,2>::Type,
	    typename ArgSets::GetASEntry<ArgSet,3>::Type,
	    typename ArgSets::GetASEntry<ArgSet,4>::Type,
	    typename ArgSets::GetASEntry<ArgSet,5>::Type,
	    typename ArgSets::GetASEntry<ArgSet,6>::Type,
	    typename ArgSets::GetASEntry<ArgSet,7>::Type
	    >::Type Type;
    };
        
    template<typename Func,typename ArgSet>
    struct ExtractResultFromHelper<Func,ArgSet,8>
    {
	typedef typename Func::template ResultHelper<
	    typename ArgSets::GetASEntry<ArgSet,1>::Type,
	    typename ArgSets::GetASEntry<ArgSet,2>::Type,
	    typename ArgSets::GetASEntry<ArgSet,3>::Type,
	    typename ArgSets::GetASEntry<ArgSet,4>::Type,
	    typename ArgSets::GetASEntry<ArgSet,5>::Type,
	    typename ArgSets::GetASEntry<ArgSet,6>::Type,
	    typename ArgSets::GetASEntry<ArgSet,7>::Type,
	    typename ArgSets::GetASEntry<ArgSet,8>::Type
	    >::Type Type;
    };
        
    template<typename Func,typename ArgSet>
    struct ExtractResultFromHelper<Func,ArgSet,9>
    {
	typedef typename Func::template ResultHelper<
	    typename ArgSets::GetASEntry<ArgSet,1>::Type,
	    typename ArgSets::GetASEntry<ArgSet,2>::Type,
	    typename ArgSets::GetASEntry<ArgSet,3>::Type,
	    typename ArgSets::GetASEntry<ArgSet,4>::Type,
	    typename ArgSets::GetASEntry<ArgSet,5>::Type,
	    typename ArgSets::GetASEntry<ArgSet,6>::Type,
	    typename ArgSets::GetASEntry<ArgSet,7>::Type,
	    typename ArgSets::GetASEntry<ArgSet,8>::Type,
	    typename ArgSets::GetASEntry<ArgSet,9>::Type
	    >::Type Type;
    };
        
    template<typename Func,typename ArgSet>
    struct ExtractResultFromHelper<Func,ArgSet,10>
    {
	typedef typename Func::template ResultHelper<
	    typename ArgSets::GetASEntry<ArgSet,1>::Type,
	    typename ArgSets::GetASEntry<ArgSet,2>::Type,
	    typename ArgSets::GetASEntry<ArgSet,3>::Type,
	    typename ArgSets::GetASEntry<ArgSet,4>::Type,
	    typename ArgSets::GetASEntry<ArgSet,5>::Type,
	    typename ArgSets::GetASEntry<ArgSet,6>::Type,
	    typename ArgSets::GetASEntry<ArgSet,7>::Type,
	    typename ArgSets::GetASEntry<ArgSet,8>::Type,
	    typename ArgSets::GetASEntry<ArgSet,9>::Type,
	    typename ArgSets::GetASEntry<ArgSet,10>::Type
	    >::Type Type;
    };
        
    // get the return type for a function called with a given arg set
    // if it has a ResultHelper member template, use that
    // otherwise, if it has a result_type typedef, use that
    // otherwise, deduce the result.
    template<typename Func,typename ArgSet>
    struct RTHelper
    {
	typedef typename CT::If<HasResultHelper<Func>::result,
				ExtractResultFromHelper<Func,ArgSet>,
				typename CT::If<HasResultType<Func>::result,
						ExtractResultType<Func>,
						DeduceReturnType<Func,ArgSet>
	                                       >::Type
	                       >::Type::Type Type;
    };
    
    // for function pointers, just use the return type
    template<typename RT,typename ArgSet>
    struct RTHelper<RT(*)(),ArgSet>
    {
	typedef RT Type;
    };

    template<typename RT,
	     typename A1,
	     typename ArgSet>
    struct RTHelper<RT(*)(A1),ArgSet>
    {
	typedef RT Type;
    };
    
    template<typename RT,
	     typename A1,
	     typename A2,
	     typename ArgSet>
    struct RTHelper<RT(*)(A1,A2),ArgSet>
    {
	typedef RT Type;
    };

    template<typename RT,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename ArgSet>
    struct RTHelper<RT(*)(A1,A2,A3),ArgSet>
    {
	typedef RT Type;
    };

    template<typename RT,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename ArgSet>
    struct RTHelper<RT(*)(A1,A2,A3,A4),ArgSet>
    {
	typedef RT Type;
    };

    template<typename RT,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename A5,
	     typename ArgSet>
    struct RTHelper<RT(*)(A1,A2,A3,A4,A5),ArgSet>
    {
	typedef RT Type;
    };
    template<typename RT,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename A5,
	     typename A6,
	     typename ArgSet>
    struct RTHelper<RT(*)(A1,A2,A3,A4,A5,A6),ArgSet>
    {
	typedef RT Type;
    };
    template<typename RT,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename A5,
	     typename A6,
	     typename A7,
	     typename ArgSet>
    struct RTHelper<RT(*)(A1,A2,A3,A4,A5,A6,A7),ArgSet>
    {
	typedef RT Type;
    };
    template<typename RT,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename A5,
	     typename A6,
	     typename A7,
	     typename A8,
	     typename ArgSet>
    struct RTHelper<RT(*)(A1,A2,A3,A4,A5,A6,A7,A8),ArgSet>
    {
	typedef RT Type;
    };
    template<typename RT,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename A5,
	     typename A6,
	     typename A7,
	     typename A8,
	     typename A9,
	     typename ArgSet>
    struct RTHelper<RT(*)(A1,A2,A3,A4,A5,A6,A7,A8,A9),ArgSet>
    {
	typedef RT Type;
    };
    template<typename RT,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename A5,
	     typename A6,
	     typename A7,
	     typename A8,
	     typename A9,
	     typename A10,
	     typename ArgSet>
    struct RTHelper<RT(*)(A1,A2,A3,A4,A5,A6,A7,A8,A9,A10),ArgSet>
    {
	typedef RT Type;
    };
}

#endif
